<?php 

if (!defined('FORUM')) die();

function pan_rss_posting_add_post($posting_info, $item_info, $fid=0, $tid=0)
{
	global $forum_db, $topic_info;
	
	$post_info = array(
		'is_guest'		=> $posting_info['user_id'] == '1' && !empty($item_info['author_name']) ? $item_info['author_name'] : '',
		'poster'		=> $posting_info['user_id'] == '1' && !empty($item_info['author_name']) ? $item_info['author_name'] : $posting_info['username'],
		'poster_id'		=> $posting_info['user_id'],
		'poster_email'	=> null,
		'subject'		=> isset($item_info['title']) ? $item_info['title'] : null,
		'message'		=> isset($item_info['content']) ? $item_info['content'] : '',
		'hide_smilies'	=> 0,
		'posted'		=> isset($item_info['pub_date']) ? $item_info['pub_date'] : time(),
		'subscr_action'	=> 0,
		'topic_id'		=> ($tid > 0) ? $tid : $posting_info['topic_id'],
		'forum_id'		=> ($fid > 0) ? $fid : $posting_info['forum_id'],
		'update_user'	=> true,
		'update_unread'	=> true
	);

	($hook = get_hook('pan_rss_posting_pre_add_post')) ? eval($hook) : null;
	add_post($post_info, $new_pid);

	if ($posting_info['title_msg'] == '1' && ($new_pid > 0) && $forum_db->field_exists('posts', 'post_title'))
	{
		$query = array(
			'UPDATE'	=> 'posts',
			'SET'		=> 'post_title=\''.$forum_db->escape($post_info['subject']).'\'',
			'WHERE'		=> 'id='.$new_pid
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
	}
	
	//
	if ($posting_info['cleaning'] == '2' && ($posting_info['max_msg'] < $topic_info['num_replies']) && ($topic_info['first_post_id'] > 0))
	{
		$query = array(
			'SELECT'	=> 'id',
			'FROM'		=> 'posts',
			'WHERE'		=> 'topic_id='.$posting_info['topic_id'].' AND id!='.$first_post_id,
			'ORDER BY'	=> 'id ASC',
			'LIMIT'		=> '1'
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$del_post = $forum_db->fetch_assoc($result);

		if (isset($del_post['id'])) {
			//delete_post($id, $tid, $fid);
			delete_post($del_post['id'], $posting_info['topic_id'], $posting_info['forum_id']);
		}
	}
	
}


function pan_rss_posting_add_topic($posting_info, $item_info)
{
	global $forum_db;

	$post_info = array(
		'is_guest'		=> '',
		'poster'		=> $posting_info['user_id'] == '1' && !empty($item_info['author_name']) ? $item_info['author_name'] : $posting_info['username'],
		'poster_id'		=> $posting_info['user_id'],
		'poster_email'	=> null,
		'subject'		=> isset($item_info['title']) ? $item_info['title'] : '',
		'message'		=> isset($item_info['content']) ? $item_info['content'] : '',
		'hide_smilies'	=> 0,
		'posted'		=> isset($item_info['pub_date']) ? $item_info['pub_date'] : time(),
		'subscribe'		=> 0,
		'forum_id'		=> $posting_info['forum_id'],
		'forum_name'	=> $posting_info['forum_name'],
		'update_user'	=> true,
		'update_unread'	=> true
	);

	($hook = get_hook('pan_rss_posting_pre_add_topic')) ? eval($hook) : null;
	add_topic($post_info, $new_tid, $new_pid);
		
	//Здесь активируем канал и присваиваем ID для постинга в тему
	if ($new_tid)
	{
		$query = array(
			'UPDATE'	=> 'pan_rss_posting',
			'SET'		=> 'topic_id='.$new_tid,
			'WHERE'		=> 'id='.$posting_info['id']
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		PanRssPostingGenCache();
	}

}


function PanRssPostingGetOptions($channel_info)
{
	global $forum_db;
	$output = true;

	if($channel_info['time_check'] == '1' && $channel_info['time_start'] > time())
		$output = false;

	if($channel_info['time_check'] == '1' && $channel_info['time_stop'] < time())
		$output = false;

	if($channel_info['time_interval'] != '0' && time() > $channel_info['time_next'])
	{
		$time_next = ($channel_info['time_interval']*60)+time();
		$query = array(
			'UPDATE'	=> 'pan_rss_posting',
			'SET'		=> 'time_next=\''.$time_next.'\'',
			'WHERE'		=> 'id='.$channel_info['id']
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);

		PanRssPostingGenCache();

	}
	else if ($channel_info['time_interval'] != '0' && time() < $channel_info['time_next'])
	{
		$output = false;
	}

	return $output;
}

function PanRssPostingFormatContent($channel_info, $item, $content)
{
	$text = html_entity_decode($content);
	@preg_match_all('#<img.*src="(.*)".*>#isU', $text, $match);

	if(isset($match[0]) && isset($match[1]))
	{
		$i = 0;
		foreach ($match[0] as $key => $val)
		{
			if(isset($match[0][$key]) && isset($match[1][$key]) && $channel_info['max_img'] > $i)
				$text = str_replace($match[0][$key], '[img]'.$match[1][$key].'[/img]'."\n", $text);

			$i++;
		}
	}

	//Transformation Tags
	$replace_tags = array(
		'<p>' => '',
		'</p>' => "\n",
		'<b>' => '[b]',
		'</b>' => '[/b]',
		'<strong>' => '[b]',
		'</strong>' => '[/b]',
	);
	foreach($replace_tags as $in => $out)
		$text = str_replace($in, $out, $text);

	$text = strip_tags($text);

	$link = strip_tags($item->link);
	if($channel_info['source_link'] == '1' && !empty($link))
		$text .= "\n".'[url='.$link.']_источник[/url]';

	return $text;
}

//Получить информацию о топике
function pan_rss_posting_get_topic_info($tid)
{
	global $forum_db;
	
	$default_topic_info = array(
		'id'			=> '0',
		'subject'		=> '',
		'first_post_id'	=> '0',
		'last_post'		=> time(),
		'num_views'		=> '0',
		'num_replies'	=> '0',
	);
	
	if ($tid > 0)
	{
		$topic_info = array();
		$query = array(
			'SELECT'	=> 'id, subject, first_post_id, last_post, num_views, num_replies',
			'FROM'		=> 'topics',
			'WHERE'		=> 'id='.$tid
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$topic_info = $forum_db->fetch_assoc($result);
		
		return $topic_info;
	}
	else
		return $default_topic_info;
}


//Выводим настройки в массив $rss_posting_info
if (file_exists(FORUM_ROOT.$forum_url['pan_rss_posting_cache'].'/pan_rss_posting_cache.php'))
	require FORUM_ROOT.$forum_url['pan_rss_posting_cache'].'/pan_rss_posting_cache.php';
else
{
	$rss_posting_info = array();
	$query = array(
		'SELECT'	=> '*',
		'FROM'		=> 'pan_rss_posting',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($rows = $forum_db->fetch_assoc($result))
		$rss_posting_info[$rows['id']] = $rows;
		
	PanRssPostingGenCache();
}

// Проверяем массив на существование
if (isset($rss_posting_info))
{
	$channel_output = array();
	//Разбиваем настройки кеша на ключ и массив настроек каждого канала
	foreach ($rss_posting_info as $key => $channel_info)
	{
		$validate = PanRssPostingGetOptions($channel_info);

		if ($validate === true)
		{
			//загружаем все новости канала
			$xml_files = @simplexml_load_file($channel_info['url'], null, LIBXML_NOCDATA);
			$item_output = array();

			//Разбиваем канал на ленты и формируем массив
			foreach ($xml_files->channel->item as $item)
			{
				$pub_date = strtotime($item->pubDate);
				$title = strip_tags($item->title);
				$namespaces = $item->getNameSpaces(true);
				
				//content:encoded
				if(isset($namespaces['content'])) {
					$content_enc = $item->children($namespaces['content']);
					$content = PanRssPostingFormatContent($channel_info, $item, $content_enc->encoded);
				} else if (isset($item->description)) {
					$content = PanRssPostingFormatContent($channel_info, $item, $item->description);
				} else {
					$content = '';
				}
				
				//dc:creator
				if(isset($namespaces['dc'])) {
					$dc = $item->children($namespaces['dc']);
					$author_name = strip_tags($dc->creator);
				}
				else
				{
					$author_name = '';
				}
					
				$link = strip_tags($item->link);

				$item_info = array(
					'pub_date'		=> $pub_date,
					'title'			=> $title,
					'content'		=> $content,
					'author_name'	=> $author_name,
					'link'			=> $link,
				);

				//сортировка по дате в обратном порядке
				$item_output[$pub_date] = $item_info;
				ksort($item_output);
			}
			
			$channel_output[$channel_info['id']] = $item_output;
		}
	}
	
	
	// Разбить массив кеша
	foreach ($rss_posting_info as $ids => $posting_info)
	{
			$i_topic = $i_post = 0;
		
		if(isset($channel_output[$ids]) && is_array($channel_output[$ids]))
		{
			// Получаем информацию о топике
			$topic_info = pan_rss_posting_get_topic_info($posting_info['topic_id']);
			
			// разбиваем массив фидов на отдельные новости
			foreach ($channel_output[$ids] as $pub_date => $item_info)
			{
				
				// Проверяем активирован ли постинг в тему
				if ($posting_info['topic_id'] > 0 && ($item_info['pub_date'] > $topic_info['last_post']) && ($posting_info['num_posts'] > $i_post))
				{
					// Add New Message
					pan_rss_posting_add_post($posting_info, $item_info);
					
					$i_post++;
					
if ($forum_user['g_id'] == FORUM_ADMIN)
{
	echo '<pre>';
//	print_r($i_post);
	echo '</pre>';
}
					
					
//					if ($i_post > 0)
//						break;
				}
				// Если же находим не активированный канал для постинга в тему
				else if ($posting_info['topic_id'] == '0' && !empty($item_info['title']) && $posting_info['num_topics'] > $i_topic) 
				{
					
					// ищем в точности похожую тему
					$query = array(
						'SELECT'	=> 'id, last_post, forum_id',
						'FROM'		=> 'topics',
						'WHERE'		=> 'subject=\''.$forum_db->escape($item_info['title']).'\'',
					);
					$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
					$next_post = $forum_db->fetch_assoc($result);
					
					// Если темф с таким названием существует то добавить в нее новое сообщение
					if (isset($next_post['id']))
					{
						// Если текущее сообщение свежее опубликованного
						if ($item_info['pub_date'] > $next_post['last_post'])
						{
							pan_rss_posting_add_post($posting_info, $item_info, $next_post['forum_id'], $next_post['id']);
							
							$i_post++;
							
//							if ($i_post > 0)
//								break;
						}
					}
					else
					{
						pan_rss_posting_add_topic($posting_info, $item_info);
						
						$i_topic++;
					}
					
				}

			}
		}

		if ($posting_info['cleaning'] == '1')
		{
			// Если выполняется одно из условий удалить канал
			if ($posting_info['max_views'] < $topic_info['num_views'] || ($posting_info['max_msg'] < $topic_info['num_replies']) || ($posting_info['time_stop'] < time()))
			{
				$query = array(
					'DELETE'	=> 'pan_rss_posting',
					'WHERE'		=> 'id='.$posting_info['id']
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
				
				PanRssPostingGenCache();
			}
		}
	}
}


